SystemOrganization addCategory: #RPSS!

WAComponent subclass: #RPSS_Main
	instanceVariableNames: 'system visitor administrator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Main class methodsFor: 'testing' stamp: 'BogatchevOleg 10/16/2011 13:21'!
canBeRoot
	^true.! !

!RPSS_Main methodsFor: 'initialization' stamp: 'BogatchevOleg 10/19/2011 15:38'!
initialize 
	super initialize.
	system := RPSS_System uniqueInstance.
	visitor := RPSS_Visitor new.
	system isInitialized 
	ifFalse: 
	[
		administrator := RPSS_Administrator new.
	].
	page := nil.
	! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/19/2011 08:03'!
renderContentOn: html
		html div class: #header; with: [self renderHeader: html].
		html div class: #menu; with: [self renderMenu: html].
		html div class: #main; with: [self renderMain: html].
		html div class: #footer; with: [self renderFooter:html].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/18/2011 20:50'!
renderFirstAdministrator: html
	html form: 
	[
		html paragraph: 'Your e-mail adress:'.
		html textInput callback: [ :value | administrator email: value ].
		html paragraph: 'Your password:'.
		html textInput
			type: 'password';
			callback: [ :value | administrator password: value ].
		html break.
		html paragraph: 'Email confirmation'.
		html checkbox
			value: true;
			callback: [ :value | administrator confirmEmail: value ].
		html break.
		html paragraph: 'Email confirmation of every new user'.
		html checkbox
			value: true;
			callback: [ :value | system userApprovedByAdmin: value ].
		html break.
		html submitButton
			callback: [ administrator create: html];
			value: 'Initialize!!'
	]! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/16/2011 22:24'!
renderFooter: html
	html paragraph: 'FOOTER'.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/16/2011 22:24'!
renderHeader: html
	html paragraph: 'HEADER'.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/21/2011 10:10'!
renderMain: html
	system isInitialized 
	ifTrue: 
	[
		visitor message = ''
		ifTrue: 
		[
			visitor module = nil
			ifTrue: 
			[
				html paragraph: 'Welcome to RPSS by groupe 9, system is ready'.
				html paragraph: 'Please login or create a new user'.
			]
			ifFalse: 
			[	
				html render: visitor module.
			].
		]
		ifFalse: 
		[
			self renderMessage: html.
		].	
	]
	ifFalse: 
	[
		html paragraph: 'System is not yet initialized, please input the administrator data'.
		self renderFirstAdministrator: html.
	].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 18:32'!
renderMenu: html
	visitor isLogedIn 
	ifTrue: 
	[
			visitor isAdministrator 
			ifTrue: 
			[
				html paragraph: [html anchor callback: [visitor setModule: RPSS_AdminPanel new. visitor module setVisitor: visitor. visitor module setPage:'approvals']; with: 'Pending approvals'].
			]
			ifFalse: 
			[
		
			].
			html paragraph: [html anchor callback: [visitor setModule: RPSS_UserPage new. visitor module setVisitor: visitor. visitor module setPage: 'personal']; with: 'Personal data'].
			html paragraph: [html anchor callback: [visitor logout]; with: 'Logout']..
	]
	ifFalse: 
	[
		html paragraph: [html anchor callback: [visitor setModule: visitor.]; with: 'Login'].
		html paragraph: [html anchor callback: [visitor setModule: RPSS_UserCreation new. visitor module setVisitor: visitor]; with: 'Register'].
	].
! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/19/2011 14:21'!
renderMessage:html
	html paragraph: 'System message: ', visitor message.
	visitor setMessage: ''.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/17/2011 11:32'!
style 
	^ '.header {
	height: 100px;
	width: 100%;
	position: relative;
	vertical-align: top;
}
.menu {
	width: 100px;
	position: relative;
	float: left;
	left: 0px;
	top: 0px;
}
.footer{
	width: 100%;
	position: static;
	vertical-align: bottom;
	clear: both;
	float: none;
	height: 100px;
}
.main {
	position: relative;
	float: left;
	left: 0px;
	top: 0px;
}'! !

WAComponent subclass: #RPSS_SiteModule
	instanceVariableNames: 'visitor page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_SiteModule subclass: #RPSS_AdminPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_AdminPanel methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 22:40'!
initialize 
	super initialize.
	page := 'approvals'.! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'BogatchevOleg 10/21/2011 23:02'!
renderContentOn: html
	|system|
	system := RPSS_System uniqueInstance.
	html paragraph: 'New users waiting to be approved:'.
	RPSS_System uniqueInstance usersToApprove do: [ :user |
	html form: [
		html text: user email.
		html submitButton value: 'Approve'; callback: [system approveUser: user email].
		html submitButton value: 'Deny'; callback: [system denyUser: user email].
		html break.
	]
]! !

!RPSS_SiteModule methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 16:22'!
initialize 
	super initialize.! !

!RPSS_SiteModule methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:39'!
setPage: aPage
	page := aPage.! !

!RPSS_SiteModule methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:23'!
setVisitor: aVisitor
	visitor := aVisitor.! !

RPSS_SiteModule subclass: #RPSS_UserCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:48'!
confirmCreation: anEmail with: html
	|system user urlApp urlDen|	
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	user markEmailConfirmed.
	system isUserApprovedByAdmin
	ifTrue: 
	[
		urlApp := html actionUrl copy.
		urlApp addField: (html callbacks store: (WAActionCallback on: [ system approveUser: anEmail ])).
		urlDen := html actionUrl copy.
		urlDen addField: (html callbacks store: (WAActionCallback on: [ system denyUser: anEmail ])).
		(RPSS_MailSender uniqueInstance) sendApprovalToAdmin: urlApp and: urlDen for: anEmail. 
	]
	ifFalse:
	[
		user approveByAdministrator.
	].
	visitor setMessage: 'User approved'.
	! !

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/20/2011 23:40'!
confirmEmail: anEmail
	|system user|	
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	user markEmailConfirmed.
	page := 'emailConfirm'.! !

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:46'!
create: html
	|system url mail newUser|
	system := RPSS_System uniqueInstance.
	mail := RPSS_MailSender uniqueInstance.
	url := html actionUrl copy.
	url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmail: visitor email ])).
	(system verifyPassword: visitor password) & (system verifyEmail: visitor email)
	ifTrue: 
	[
		(system isEmailOccupied: visitor email)
		ifFalse: 
		[
			newUser := RPSS_User new.
			newUser fromVisitor: visitor.
			system addUser: newUser.
			mail sendEmailConfirmationTo: visitor email withUrl: url.
			visitor setMessage: 'Please confirm your email!!'.
		]
		ifTrue: 
		[
			visitor setMessage: 'This email is already taken!!'.
		].
	]
	ifFalse: 
	[
		visitor setMessage: 'Wrong email or password!!'.
	].! !

!RPSS_UserCreation methodsFor: 'initialization' stamp: 'BogatchevOleg 10/20/2011 23:13'!
initialize 
	super initialize.
	page := 'RegisterForm'.! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:33'!
renderContentOn: html
	page = 'RegisterForm'
	ifTrue:
	[
		self renderRegistrationForm: html.
	].
	page = 'emailConfirm'
	ifTrue: 
	[
		self renderEmailConfirmation: html.
	]! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:30'!
renderEmailConfirmation: html
	|system|
	system := RPSS_System uniqueInstance.	
	html paragraph: 'Thank you for confirming your email'.
	system userApprovedByAdmin 
	ifTrue: 
	[
		self confirmCreation: visitor email with: html. 
	
	
		html paragraph: 'Administrator will approve your registration shortly'.
	].! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:34'!
renderRegistrationForm: html
	html form: 
	[
		html paragraph: 'Your e-mail adress:'.
		html textInput callback: [ :value | visitor email: value ].
		html paragraph: 'Your password:'.
		html textInput
			type: 'password';
			callback: [ :value | visitor password: value ].
		html break.
		html submitButton
			callback: [ self create: html];
			value: 'Register!!'
	].! !

RPSS_SiteModule subclass: #RPSS_UserPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:55'!
changeEmail: html
	|system mail url|
	mail := RPSS_MailSender uniqueInstance.
	system := RPSS_System uniqueInstance.
	((system verifyEmail: visitor tempEmail) &  ((system isEmailOccupied: visitor tempEmail) not))
	ifTrue:
	[
		url := html actionUrl copy.
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmailChange: visitor tempEmail ])).
		mail sendEmailChangeTo: visitor email with: visitor tempEmail url: url.
	].
	visitor setMessage: 'You will receive a confirmation email with a link to confirm your change.'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:23'!
changePassword: html
	|system mail url|
	mail := RPSS_MailSender uniqueInstance.
	system := RPSS_System uniqueInstance.
	(system verifyPassword: visitor tempPassword)
	ifTrue:
	[
		url := html actionUrl copy.
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmPasswordChange: visitor tempPassword])).
		mail sendPasswordChangeTo: visitor email url: url.
	].
	visitor setMessage: 'You will receive a confirmation email with a link to confirm your change.'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:09'!
confirmEmailChange: aNewEmail
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: visitor email.
	system transferUserFrom: user email to: aNewEmail. 
	visitor setMessage: 'You successfuly changed your email'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:18'!
confirmPasswordChange: aNewPassword
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: visitor email.
	user password: aNewPassword.
	visitor setMessage: 'You successfuly changed your password'.! !

!RPSS_UserPage methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 16:26'!
initialize 
	super initialize.
	page := 'overview'.! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 16:40'!
renderChangeEmail: html
	html paragraph: 'Please input your new email'.
	html form: 
	[
		html textInput callback: [:value | visitor tempEmail: value].
		html break.
		html submitButton callback: [self changeEmail: html.]; value: 'Modify!!'.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 18:25'!
renderChangePassword: html
	html paragraph: 'Please input your new password'.
	html form: 
	[
		html textInput type: 'password'; callback: [:value | visitor tempPassword: value].
		html break.
		html submitButton callback: [self changePassword: html.]; value: 'Modify!!'.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 12:19'!
renderContentOn: html
	page = 'overview'
	ifTrue: 
	[
		html paragraph: 'Overview'.
	].
	page = 'personal'
	ifTrue: 
	[
		self renderPersonal: html.
	].
	page = 'changePassword'
	ifTrue:  
	[
		self renderChangePassword: html.
	].
	page = 'changeEmail'
	ifTrue: 
	[
		self renderChangeEmail: html.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 15:34'!
renderPersonal: html
	html paragraph: [html anchor callback: [page := 'changeEmail']; with: 'Change email'].
	html paragraph: [html anchor callback: [page := 'changePassword']; with: 'Change password'].! !

WAComponent subclass: #RPSS_Visitor
	instanceVariableNames: 'email administrator password confirmEmail message logedIn module tempEmail tempPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_Visitor subclass: #RPSS_Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Administrator methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/19/2011 20:03'!
confirmCreation
	|system newAdmin|
	system := RPSS_System uniqueInstance.
	(system isEmailOccupied: email)
	ifFalse: 
	[
		newAdmin := RPSS_User new.
		newAdmin email: email.
		newAdmin password: password.
		newAdmin markEmailConfirmed.
		newAdmin markAsAdministrator.
		newAdmin approveByAdministrator.
		system addUser: newAdmin.
		system finishInitialization.
		system setFirstAdministrator: newAdmin.
	]
	ifTrue: 
	[
		message := 'emailOccupied'.
	].
! !

!RPSS_Administrator methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/22/2011 17:43'!
create: html
	|system url mail|
	system := RPSS_System uniqueInstance.
	mail := RPSS_MailSender uniqueInstance.
	url := html actionUrl copy.
	url addField: (html callbacks store: (WAActionCallback on: [ self confirmCreation ])).
	(system verifyPassword: password) & (system verifyEmail: email)
	ifTrue: 
	[
		mail sendEmailConfirmationTo: email withUrl: url.
	].
	self setMessage: 'Please confirm your email.'.
	! !

!RPSS_Administrator methodsFor: 'initialization' stamp: 'BogatchevOleg 10/17/2011 22:23'!
initialize
	super initialize.
	! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 10:23'!
administrator: value
	administrator := value.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:59'!
confirmEmail
	^confirmEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 12:00'!
confirmEmail: aConfirm
	confirmEmail := aConfirm.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:49'!
email
	^email.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:49'!
email: anEmail
	email := anEmail.! !

!RPSS_Visitor methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 10:24'!
fromUser: anEmail
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	self email: user email.
	self password: user password.
	self administrator: user administrator.! !

!RPSS_Visitor methodsFor: 'initialization' stamp: 'BogatchevOleg 10/22/2011 16:39'!
initialize 
	super initialize.
	email := ''.
	password := ''.
	logedIn := false.
	administrator := false.
	confirmEmail := true.
	message := ''.
	module := nil.
	tempEmail := ''.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 10:22'!
isAdministrator
	^administrator.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 14:38'!
isLogedIn
	^logedIn.! !

!RPSS_Visitor methodsFor: 'servicies' stamp: 'BogatchevOleg 10/21/2011 16:28'!
login: html
	|system|
	system := RPSS_System uniqueInstance.
	(system isUserAutorized: (self email) password: (self password))
	ifTrue: 
	[
		self fromUser: email.
		logedIn := true.
		self setModule: (RPSS_UserPage new setVisitor: self).
	]
	ifFalse: 
	[
		self setMessage: 'Wrong login/password or user not approved by administrator!!'.
	]. 
	! !

!RPSS_Visitor methodsFor: 'servicies' stamp: 'BogatchevOleg 10/22/2011 18:31'!
logout
	password := ''.
	email := ''.
	logedIn := false.
	administrator := false.
	message := ''.
	module := nil.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 07:02'!
message
	^message.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/20/2011 23:08'!
module
	^module.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:50'!
password
	^password.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:50'!
password: aPassword
	password := aPassword.! !

!RPSS_Visitor methodsFor: 'rendering' stamp: 'BogatchevOleg 10/21/2011 10:19'!
renderContentOn: html
	html paragraph: 'To login, please provide the following information'.
	html 	form: 
			[
				html 	paragraph: 'Your e-mail adress:'.
				html 	textInput callback: [:value | self email: value].
				html 	paragraph: 'Your password:'.
				html 	textInput type: 'password'; callback: [:value | self password: value].
				html 	break.
				html 	submitButton callback: [ self login:html]; value: 'Login!!'.
			].! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 07:03'!
setMessage: aMessage.
	message := aMessage.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/20/2011 23:08'!
setModule: aModule
	module := aModule.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 16:39'!
tempEmail
	^tempEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 16:40'!
tempEmail: anEmail
	tempEmail := anEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 18:14'!
tempPassword
	^tempPassword.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 18:14'!
tempPassword: aPassword
	tempPassword := aPassword.! !

Object subclass: #RPSS_MailSender
	instanceVariableNames: 'emailFrom localhost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_MailSender class
	instanceVariableNames: 'uniqueInstance'!

RPSS_MailSender class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_MailSender class methodsFor: 'instance destruction' stamp: 'BogatchevOleg 10/17/2011 17:27'!
reset
	uniqueInstance := nil.! !

!RPSS_MailSender class methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/17/2011 23:01'!
uniqueInstance
	uniqueInstance ifNil: 
	[
		uniqueInstance := self new.
	].
	^uniqueInstance.! !

!RPSS_MailSender methodsFor: 'initialization' stamp: 'BogatchevOleg 10/18/2011 21:06'!
initialize
	super initialize.
	emailFrom := 'rpss@ulb.ac.be'.
	localhost := WideString fromString: 'http://localhost:8080'.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'BogatchevOleg 10/20/2011 23:52'!
sendApprovalTo: anEmail
	|msg to from subject body bodyhtml content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	bodyhtml := 'You have been approved!! '.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'BogatchevOleg 10/20/2011 23:43'!
sendApprovalToAdmin: urlApp and: urlDen for: email
	|msg to from subject body bodyhtml content administrator linkApp linkDen|
	administrator := (RPSS_System uniqueInstance) firstAdministrator.
	
	to := MIMEHeaderValue forField: 'to' fromString: administrator email.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	linkApp := localhost, urlApp greaseString.
	linkDen := localhost, urlDen greaseString.
	bodyhtml := 'A new user created an account, please validate him, his email: ', email, ' to validate ',linkApp, ' to reject ', linkDen.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'BogatchevOleg 10/19/2011 20:22'!
sendDenialTo: anEmail
	|msg to from subject body bodyhtml content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	bodyhtml := 'You have been denied!! '.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 16:55'!
sendEmailChangeTo: anEmail with: newEmail url: aUrl
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, aUrl greaseString.
	bodyhtml := 'Please confirm that you want to change your mail from: ', anEmail, ' to ', newEmail,' with this link:', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'BogatchevOleg 10/18/2011 21:08'!
sendEmailConfirmationTo: anEmail withUrl: url
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, url greaseString.
	bodyhtml := 'You can confirm your email via this link: ', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:16'!
sendPasswordChangeTo: anEmail url: aUrl
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, aUrl greaseString.
	bodyhtml := 'Please confirm that you want to change your password with this link:', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

Object subclass: #RPSS_System
	instanceVariableNames: 'collection initialized emailConfRequired userApprovedByAdmin firstAdministrator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_System class
	instanceVariableNames: 'uniqueInstance'!

RPSS_System class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_System class methodsFor: 'instance destruction' stamp: 'BogatchevOleg 10/19/2011 07:58'!
reset
	uniqueInstance := nil.
	RPSS_MailSender reset.! !

!RPSS_System class methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/17/2011 15:15'!
uniqueInstance
	uniqueInstance ifNil: [uniqueInstance := self new].
	^uniqueInstance.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/17/2011 15:17'!
addUser: aUser
	collection at: (((aUser email) onlyLetters ) asSymbol ) put: aUser.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/21/2011 16:45'!
approveUser: anEmail
	|user mail|
	(self isEmailOccupied: anEmail)
	ifTrue: 
	[
		user := self getUserWithEmail: anEmail.
		mail := RPSS_MailSender uniqueInstance.
		user approveByAdministrator.
		mail sendApprovalTo: anEmail.
	].! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 15:16'!
collection
	^collection.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/21/2011 22:20'!
denyUser: anEmail
	|mail user|
	mail := RPSS_MailSender uniqueInstance.
	(self isEmailOccupied: anEmail)
	ifTrue: 
	[
		collection removeKey: ((anEmail onlyLetters ) asSymbol ).
		mail sendDenialTo: anEmail.
	].! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:56'!
finishInitialization
	initialized := true.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/19/2011 20:01'!
firstAdministrator
	^firstAdministrator.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/21/2011 16:14'!
getUserWithEmail: anEmail
	^(collection at: ((anEmail) onlyLetters) asSymbol).! !

!RPSS_System methodsFor: 'initialization' stamp: 'BogatchevOleg 10/19/2011 20:01'!
initialize
	super initialize.
	collection := IdentityDictionary new.
	initialized := false.
	emailConfRequired := true.
	userApprovedByAdmin := true.
	firstAdministrator := nil.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 15:17'!
isEmailConfRequired
	^emailConfRequired.! !

!RPSS_System methodsFor: 'testing' stamp: 'BogatchevOleg 10/18/2011 21:23'!
isEmailOccupied: anEmail
	^(collection includesKey:  (((anEmail) onlyLetters ) asSymbol )).! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:47'!
isInitialized 
	^initialized.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:49'!
isUserApprovedByAdmin
	^userApprovedByAdmin.! !

!RPSS_System methodsFor: 'testing' stamp: 'BogatchevOleg 10/21/2011 16:09'!
isUserAutorized: anEmail password: aPassword
	|user|
	(collection includesKey: ((anEmail onlyLetters ) asSymbol))
	ifTrue: 
	[
		user := self getUserWithEmail: anEmail.
		((user password = aPassword) & (user approvedByAdministrator = true)) 
		ifTrue: 
		[
			^true.
		].
	].
	^false.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/19/2011 20:03'!
setFirstAdministrator: newAdministrator
	^firstAdministrator := newAdministrator.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/22/2011 17:09'!
transferUserFrom: anEmail to: newEmail
	|user|
	user := self getUserWithEmail: anEmail.
	collection removeKey: (((anEmail) onlyLetters) asSymbol).
	collection at: (((newEmail) onlyLetters) asSymbol) put: user.
	user email: newEmail.


	! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:47'!
userApprovedByAdmin
	^userApprovedByAdmin.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:48'!
userApprovedByAdmin: newValue
	userApprovedByAdmin := newValue.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/21/2011 23:00'!
usersToApprove
	^collection select: [:user | user isNotApprovedByAdministrator & user isEmailConfirmed ]! !

!RPSS_System methodsFor: 'servicies' stamp: 'BogatchevOleg 10/17/2011 19:16'!
verifyEmail: anEmail
	^true.! !

!RPSS_System methodsFor: 'servicies' stamp: 'BogatchevOleg 10/17/2011 19:16'!
verifyPassword: aPassword
	^true.! !

Object subclass: #RPSS_User
	instanceVariableNames: 'email password administrator emailConfirmed approvedByAdministrator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:19'!
administrator
	^administrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:19'!
administrator: value
	administrator := value.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:14'!
approveByAdministrator
	approvedByAdministrator := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:09'!
approvedByAdministrator
	^approvedByAdministrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
email
	^email.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
email: anEmail
	email := anEmail.! !

!RPSS_User methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/19/2011 16:50'!
fromVisitor: aVisitor
	email := aVisitor email.
	password := aVisitor password.
	administrator := false.
	emailConfirmed := false.
	approvedByAdministrator := false.! !

!RPSS_User methodsFor: 'initialization' stamp: 'BogatchevOleg 10/17/2011 11:52'!
initialize
	super initialize.
	email := ''.
	password := ''.
	emailConfirmed := false.
	approvedByAdministrator := false.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 19:58'!
isAdministrator
	^administrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:46'!
isApprovedByAdministrator
	^approvedByAdministrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:45'!
isEmailConfirmed
	^emailConfirmed.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:47'!
isNotApprovedByAdministrator
	^(approvedByAdministrator not).! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:13'!
markAsAdministrator
	administrator := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:14'!
markEmailConfirmed
	^emailConfirmed := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
password
	^password.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
password: aPassword
	password := aPassword.! !
